#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "readpgm.h"
#include "rotate_image.h"
#include "readpgm.c"
#include "rotate_image.c"

#define PIX(u)  unsigned char *u##D; unsigned int u##W, u##H;

static unsigned char *alloci(int w,int h,int fill)
{
  unsigned char *R;
  R= malloc(w*h);
  memset(R, fill, w*h);
  return R;
}

static void put(unsigned char *dD, int dW,int dH, 
                unsigned char *sD, int sW,int sH)
{
  int x,y;
  for(y=0;y<sH;y++)
    for(x=0;x<sW;x++)
     dD[ x+(dW-sW)/2 + (y+(dH-sH)/2)*dW]= sD[x+y*sW];
}

static void write_img(char *dst, unsigned char *D,int w,int h)
{
  FILE *f;
  f= fopen(dst,"wb");
  if (!f)
   exit(fprintf(stderr,"Can't open %s\n",dst));
  fprintf(f,"P5\n%d %d\n255\n", w,h);
  fwrite(D, 1,w*h, f);
  fclose(f);
}
int main(int argc,char **argv)
{
  char *e;
  PIX(d) PIX(b) PIX(r) PIX(f)

  if ((e=pgm_read_file(argv[1],&dD,&dW,&dH)))
   exit(fprintf(stderr,"error reading %s: %s\n",argv[1],e));

  bW= dW + 50; bH= dH + 50; bD= alloci(bW,bH,0xff);
  put(bD, bW, bH, dD, dW, dH); free(dD);

  srand(time(NULL));

  rotate_image_double_grayr(bD, bW, bH, (rand()%20-10)*M_PI/180.0, 
                            &rD, &rW, &rH);
  free(bD);
  fW= rW+50; fH= rH+50; fD= alloci(fW, fH, 0x00);

  put(fD, fW, fH, rD, rW, rH); free(rD);

  write_img(argv[1], fD, fW,fH);
  free(fD);
  return 0;
}
