#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pngio.h"

/* This program takes an image file and outputs it in graymap format.
   The first two bytes of the graymap give us the width and height.
   No declaration etc. is output. This is done to make the job of
   the resource editor easier.

   The byte-sized dimensions restrict it to 255x255 images at most,
   but we're talking about radio buttons etc. They will be fine. */

int main(int argc,char **argv)
{
  char *fn;
  int i;
  fn= argv[1];

  unsigned char *data; unsigned int w,h;
  char *e;

  e= read_png_graymap_noalpha(fn, &w,&h, &data);
  if (e) exit(fprintf(stderr,"png error: %s\n",e));

  printf("   %d, %d,",w&0xff,h&0xff);
  for(i=0;i<w*h;i++)
  {
     if (i%10==0) printf("\n    ");
     printf("0x%02x,", data[i]);
  }
  printf("\n");
  return 0;
}
